create or replace 
PROCEDURE IMPORTA_PROVEEDOR
IS 
   V_CDPAIS       VARCHAR2(4);
   V_SGESTADO     VARCHAR2(2);
   V_FORNECEDOR   VARCHAR2(20);
   V_CDMUNICIPIO  VARCHAR2(4);   
   V_CDFORNECED   VARCHAR2(21);
   V_IDTPIJURFORN VARCHAR2(1);
   V_NRINSJURFORN VARCHAR2(20);
   V_FORNOK       VARCHAR2(1);
   V_CODEERRO     VARCHAR2(10);
   V_MENSERRO     VARCHAR2(300);
   V_MUNIEXPO     VARCHAR2(5);
   V_TAMMUNI      INTEGER;
BEGIN
   FOR C_FORNECEDOR IN 
       (SELECT /*  FORNECEDOR  */
               U.CDFORNECEDOR, U.NMRAZAOSOC, U.NMFANTFORNE, U.CDPROVEESAP,
               /*  ENDEFORN  */
               U.DSENDERECO, U.CDPAIS, U.SGESTADO, U.CDMUNICIPIO, 
               U.IDINTERFACE, U.TPINTERFACE
          FROM USR_SAP_FORNECEDOR U
         WHERE U.DTINTERFACEDEST IS NULL
         ORDER BY U.DTINTERFACEORI)
   LOOP
      V_FORNOK := 'N';
      IF TRIM(C_FORNECEDOR.CDPAIS) IS NOT NULL THEN
         BEGIN
            SELECT CDPAIS
              INTO V_CDPAIS
              FROM PAIS
             WHERE SGPAIS = C_FORNECEDOR.CDPAIS;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_CDPAIS := NULL;
               INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
               VALUES(C_FORNECEDOR.IDINTERFACE, C_FORNECEDOR.TPINTERFACE, 3, SYSDATE, 1, 'Sigla del pais '||C_FORNECEDOR.CDPAIS ||'  no registrado en el sistema Teknisa.');
         END;
      ELSE
         V_CDPAIS := NULL;
         INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
         VALUES(C_FORNECEDOR.IDINTERFACE, C_FORNECEDOR.TPINTERFACE, 3, SYSDATE, 1, 'Sigla del pais no puede estar en blanco.');
      END IF;
      
      IF (V_CDPAIS IS NOT NULL) THEN
         IF TRIM(C_FORNECEDOR.SGESTADO) IS NOT NULL THEN
            BEGIN
               SELECT SGESTADO
                 INTO V_SGESTADO
                 FROM ESTADO
                WHERE CDPAIS     = V_CDPAIS
                  AND CDESTAEXPO = LPAD(C_FORNECEDOR.SGESTADO, 2, '0');
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_SGESTADO := NULL;
                  INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                  VALUES(C_FORNECEDOR.IDINTERFACE, C_FORNECEDOR.TPINTERFACE, 3, SYSDATE, 1, 'C'||CHR(243)||'digo del estado '|| C_FORNECEDOR.SGESTADO|| ' no registrado en el sistema Teknisa.');
            END;
         ELSE
            V_SGESTADO := NULL;
            INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
            VALUES(C_FORNECEDOR.IDINTERFACE, C_FORNECEDOR.TPINTERFACE, 3, SYSDATE, 1, 'C'||CHR(243)||'digo del estado no puede estar en blanco.');
         END IF;
         
         IF (V_SGESTADO IS NOT NULL) THEN
            IF TRIM(C_FORNECEDOR.CDMUNICIPIO) IS NOT NULL THEN
               SELECT LENGTH(C_FORNECEDOR.CDMUNICIPIO)
                 INTO V_TAMMUNI
                 FROM DUAL;
               
               IF V_TAMMUNI > 5 THEN
                  V_MUNIEXPO := SUBSTR(C_FORNECEDOR.CDMUNICIPIO, -5);
               ELSE
                  V_MUNIEXPO := LPAD(C_FORNECEDOR.CDMUNICIPIO, 5, '0');
               END IF;
               
               BEGIN
                  SELECT CDMUNICIPIO
                    INTO V_CDMUNICIPIO
                    FROM MUNICIPIO
                   WHERE CDPAIS     = V_CDPAIS
                     AND SGESTADO   = V_SGESTADO
                     AND CDMUNIEXPO = V_MUNIEXPO;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_CDMUNICIPIO := NULL;
                     
                     INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                     VALUES(C_FORNECEDOR.IDINTERFACE, C_FORNECEDOR.TPINTERFACE, 3, SYSDATE, 1, 'C'||CHR(243)||'digo del municipio '||V_MUNIEXPO|| ' no registrado en el sistema Teknisa.');
               END;
            ELSE
               V_CDMUNICIPIO := NULL;
               INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
               VALUES(C_FORNECEDOR.IDINTERFACE, C_FORNECEDOR.TPINTERFACE, 3, SYSDATE, 1, 'C'||CHR(243)||'digo del municipio no puede estar en blanco.');
            END IF; 
                  
            IF (V_CDMUNICIPIO IS NOT NULL) THEN
               V_NRINSJURFORN := C_FORNECEDOR.CDFORNECEDOR;
               
               BEGIN
                  SELECT MIN(NRINSJURFORN) AS CDFORNECEDOR
                    INTO V_FORNECEDOR
                    FROM FORNECEDOR
                   WHERE REGEXP_LIKE (NRINSJURFORN, '(^0*0|^)'||NVL(TRIM(V_NRINSJURFORN), '___')||'$');
                  --'(^0*0|^)' -> verifica se existe um fornecedor com essa inscricao exata ou com 0(zeros) a esquerda da variavel "V_NRINSJURFORN"
                  --'$' -> Obriga terminar com o valor de V_NRINSJURFORN
               EXCEPTION
                  WHEN OTHERS THEN
                     V_FORNECEDOR := NULL;               
               END;
               
               BEGIN
                  --IF (C_FORNECEDOR.TPINTERFACE <> 'E') THEN
                     --IF (C_FORNECEDOR.TPINTERFACE = 'I') THEN
                        IF V_FORNECEDOR IS NULL THEN
                           /*CASE 
                              WHEN LENGTH(V_NRINSJURFORN) <= 5  THEN V_IDTPIJURFORN := 'O';
                              WHEN LENGTH(V_NRINSJURFORN)  = 11 THEN V_IDTPIJURFORN := 'F';
                              WHEN LENGTH(V_NRINSJURFORN)  = 14 THEN V_IDTPIJURFORN := 'J';
                              ELSE V_IDTPIJURFORN := 'I';
                           END CASE;*/
                           --IF (V_IDTPIJURFORN = 'I') THEN
                              V_IDTPIJURFORN := 'I';
                              V_NRINSJURFORN := LPAD(V_NRINSJURFORN, 20, '0');
                              V_CDFORNECED   := V_IDTPIJURFORN||V_NRINSJURFORN;
                              
                            --  V_CDFORNECED   := V_IDTPIJURFORN||V_NRINSJURFORN;
                           /*ELSE
                              IF (V_IDTPIJURFORN = 'O') THEN
                                 V_CDFORNECED   := V_IDTPIJURFORN||V_NRINSJURFORN;
                              ELSE
                                 V_CDFORNECED := V_IDTPIJURFORN||V_NRINSJURFORN;
                              END IF;*/
                           --END IF;
                           
                           
                           

                           INSERT INTO FORNECEDOR(CDFORNECED, NMRAZSOCFORN, NMFANTFORN, IDTPIJURFORN, NRINSJURFORN, CDEXFORNECED)
                           VALUES(V_CDFORNECED, C_FORNECEDOR.NMRAZAOSOC, C_FORNECEDOR.NMFANTFORNE, V_IDTPIJURFORN, V_NRINSJURFORN, C_FORNECEDOR.CDPROVEESAP);
                           
                           INSERT INTO ENDEFORN(CDFORNECED, DSENDEFORN, CDPAIS, SGESTADO, CDMUNICIPIO, IDTPENDEFORN)
                           VALUES(V_CDFORNECED, C_FORNECEDOR.DSENDERECO, V_CDPAIS, V_SGESTADO, V_CDMUNICIPIO, 'P');
                                 
                           INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                           VALUES(C_FORNECEDOR.IDINTERFACE, C_FORNECEDOR.TPINTERFACE, 3, SYSDATE, 0, 'Proveedor '||C_FORNECEDOR.CDFORNECEDOR || ' - ' || C_FORNECEDOR.NMFANTFORNE ||' registrado con '||CHR(233)||'xito.');
                                    
                           V_FORNOK := 'S';
                        ELSE   
                           V_CDFORNECED := '';
                           SELECT CDFORNECED
                             INTO V_CDFORNECED
                             FROM FORNECEDOR
                            WHERE NRINSJURFORN = V_FORNECEDOR;
                           
                           UPDATE FORNECEDOR SET NMRAZSOCFORN = C_FORNECEDOR.NMRAZAOSOC, 
                                                 NMFANTFORN   = C_FORNECEDOR.NMFANTFORNE,
                                                 CDEXFORNECED = C_FORNECEDOR.CDPROVEESAP
                            WHERE CDFORNECED = V_CDFORNECED;
                           
                           /*  Endereo principal  */
                           UPDATE ENDEFORN SET DSENDEFORN  = C_FORNECEDOR.DSENDERECO,
                                               CDPAIS      = V_CDPAIS, 
                                               SGESTADO    = V_SGESTADO, 
                                               CDMUNICIPIO = V_CDMUNICIPIO
                            WHERE CDFORNECED = V_CDFORNECED;
                           
                           INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                           VALUES(C_FORNECEDOR.IDINTERFACE, C_FORNECEDOR.TPINTERFACE, 3, SYSDATE, 0, 'Actualizaci'||CHR(243)||'n del proveedor '|| C_FORNECEDOR.CDFORNECEDOR  || ' - ' ||  C_FORNECEDOR.NMFANTFORNE  || ' realizada con '||CHR(233)||'xito.');
                           
                           V_FORNOK := 'S';
                        END IF;
               EXCEPTION
                  WHEN OTHERS THEN
                     V_CODEERRO := SQLCODE;
                     V_MENSERRO := SQLERRM;
                     
                     INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                     VALUES(C_FORNECEDOR.IDINTERFACE, C_FORNECEDOR.TPINTERFACE, 3, SYSDATE, 1, 'Error en la operaci'||CHR(243)||'n del proveedor. Error: '||V_CODEERRO || '- '||V_MENSERRO);
                     
                     COMMIT;
               END;
            END IF;
         END IF;
      END IF;
      
      IF (V_FORNOK = 'S') THEN
         UPDATE USR_SAP_FORNECEDOR SET DTINTERFACEDEST = SYSDATE, STATUS = 0
          WHERE IDINTERFACE = C_FORNECEDOR.IDINTERFACE;
      ELSE
         UPDATE USR_SAP_FORNECEDOR SET STATUS = 2
          WHERE IDINTERFACE = C_FORNECEDOR.IDINTERFACE;
      END IF;
   END LOOP; 
   
   COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('IMPORTA_PROVEEDOR','6.05.xxx'); END;
/